/*

                                   _JNJ`                        
                               .JNMH`                           
                              JMMF`       `;.                   
                            .NMM)          `MN.                 
                            MMM)            (MML                
                           (MMM`             MMML               
                     M  I  D  N  I  G  H  T    C  o  D  E       
                           (NMMF             MHNH               
                            NMML            .MMM                
                             NMML          .NMH                 
                              4MMNL       .#F                   
                               `4HNNL_   `                      
                                   `"""`                        

                          Copyright (C) 2004-2005
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt

*/

/* main.c :: Midnight Code library test and example program		*/


#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <arpa/inet.h>

/*
#define MIDNIGHTCODE_LIST_NOLOCK
#define MIDNIGHTCODE_LIST_NOINDEX
*/
#include "libmidnightcode/libmidnightcode.h"


int
main(int argc, char **argv) {
  int ret_i;
  int showBroadcast = 1;
  int vartwo = 4;
  int help = 0;
  int list_silent = 0;
  float varthr = 1.2;
  char info[64] = "\0";
  struct in_addr ip_addr;
  struct in_addr host;;
  // int n;
  void * tmp_void_p;
  struct midnightcode_config_head_t * config_list_head_p;
  struct midnightcode_config_element_t * now_element, *old_element;
  struct midnightcode_interface_head_t * interface_list_head_p;
  // struct midnightcode_interface_element_t * now_interface;
  // u_char * uchar_p;


  /* SWITCHES */
  struct entry_struct_name {
    int test_val;
    midnightcode_list_entry(entry_struct_name);
  };

  // struct entry_struct_name *np, *op;

  struct midnightcode_switch_t switches[] = {
    { "b", "broadcast", "Example integer value",
      MIDNIGHTCODE_SWITCH_TYPE_INT, 0, 0, &showBroadcast },
    { "v", "var2", "Another example integer value",
      MIDNIGHTCODE_SWITCH_TYPE_INT, 0, 0, &vartwo },
    { "v3", "var3", "A float test value",
      MIDNIGHTCODE_SWITCH_TYPE_FLOAT, 0, 0, &varthr },
    { "i", "info", "An example string value",
      MIDNIGHTCODE_SWITCH_TYPE_STRING, 64, 0, &info },
    { "ho", "host", "A host example that returns an IP",
      MIDNIGHTCODE_SWITCH_TYPE_HOST, 0, 0, &host.s_addr },
    { "ip", "ipaddr", "An IP example that only accepts an IP",
      MIDNIGHTCODE_SWITCH_TYPE_IP, 0, 0, &ip_addr.s_addr },
    { "l", "list_silent", "On/Off - Silent list render",
      MIDNIGHTCODE_SWITCH_TYPE_NONE, 0, 0, &list_silent },
    { "h", "help", "Display this help/usage screen",
      MIDNIGHTCODE_SWITCH_TYPE_NONE, 0, 0, &help },
    { 0 }
  };


  /* CONFIG FILE */

  midnightcode_list_init(config_struct_head, midnightcode_config_element_t);
  tmp_void_p = (void *)&config_struct_head;
  config_list_head_p = tmp_void_p;

  old_element = malloc(sizeof(struct midnightcode_config_element_t));
  now_element = malloc(sizeof(struct midnightcode_config_element_t));


  /* INTERFACE STUFF */

  midnightcode_list_init(interface_struct_head,
                         midnightcode_interface_element_t);
  tmp_void_p = (void *)&interface_struct_head;
  interface_list_head_p = tmp_void_p;



  memset(&ip_addr, 0, sizeof(struct in_addr));
  memset(&host, 0, sizeof(struct in_addr));
  if((ret_i = midnightcode_switch_process(argc, argv, switches)) != 0) {
    fprintf(stdout, "\n");
    midnightcode_logo(0,
      MIDNIGHTCODE_LICENSE_STYLE_BLOOD_MOON);
    midnightcode_license(0,
      MIDNIGHTCODE_LICENSE_STYLE_BLOOD_MOON, 
      MIDNIGHTCODE_LICENSE_TEXT_COPYRIGHT);
    fprintf(stdout, "    Error in switches, switch \"%s\" is unkown"
            " at parameter number %d.\n\n", argv[ret_i], ret_i);
    midnightcode_switch_usage(MIDNIGHTCODE_SWITCH_STYLE_SOFT,
                              argv[0], switches);
    exit(1);
  }
  if(help) {
    midnightcode_logo(0,
      MIDNIGHTCODE_LICENSE_STYLE_BLOOD_MOON);
  midnightcode_license(0,
    MIDNIGHTCODE_LICENSE_STYLE_BLOOD_MOON, 
    MIDNIGHTCODE_LICENSE_TEXT_COPYRIGHT);
    midnightcode_switch_usage(MIDNIGHTCODE_SWITCH_STYLE_SOFT,
                              argv[0], switches);
    exit(1);
  }

  /*
  fprintf(stdout, "--broadcast=[%d]\n", showBroadcast);
  fprintf(stdout, "--var2=[%d]\n", vartwo);
  fprintf(stdout, "--var3=[%f]\n", varthr);
  fprintf(stdout, "--info=[%s]\n", info);
  fprintf(stdout, "-ip=[%s]\n", inet_ntoa(ip_addr));
  fprintf(stdout, "-ho=[%s]\n", inet_ntoa(host));
  */


  fflush(stdout);


  midnightcode_logo(0,
    MIDNIGHTCODE_LICENSE_STYLE_BLOOD_MOON);
  midnightcode_license(0,
    MIDNIGHTCODE_LICENSE_STYLE_BLOOD_MOON, 
    MIDNIGHTCODE_LICENSE_TEXT_ALL);


  // Status Title
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_H1,
                           MIDNIGHTCODE_STATUS_STYLE_NORMAL,
                           "Welcome to %s", argv[0]);

  // Status Section
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_H2,
                           MIDNIGHTCODE_STATUS_STYLE_SOFT,
                           "Test set for %s styles", "Logo");

  // Status
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_SOFT,
                           "This is status text that is long "
                           "and c%d%dl to look at too", 0,0);
  midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_OKAY);

  // Status
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_NORMAL,
                           "This is status text that is long "
                           "and c%d%dl to look at too", 0,0);
  midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_WARN);

  // Status
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_STRONG,
                           "This is status text");
  midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_FAIL);

  // Status blurb
  fprintf(stdout, "\n");
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_BLURB,
                           MIDNIGHTCODE_STATUS_STYLE_UNKNOWN,
                           "There appear to be no network card drivers loaded.");
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_BLURB,
                           MIDNIGHTCODE_STATUS_STYLE_UNKNOWN,
                           "Your card is not supported. Please see the CHAOS");
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_BLURB,
                           MIDNIGHTCODE_STATUS_STYLE_UNKNOWN,
                           "HOWTO or FAQ for more information or email the");
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_BLURB,
                           MIDNIGHTCODE_STATUS_STYLE_UNKNOWN,
                           "list and provide details of this system.");
  fprintf(stdout, "\n");
  fflush(stdout);

  // Status
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_UNKNOWN,
                           "This is status text");
  midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_UNKNOWN);

  fprintf(stdout, "\n\n");


  // CONFIG FILE TEST

  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_NORMAL,
                           "Config file [%s] load and parse", "test.cfg");
  if((ret_i = midnightcode_config_read("test.cfg",
                         config_list_head_p,
                         MIDNIGHTCODE_CONFIG_TYPE_NEWSET,
                         MIDNIGHTCODE_CONFIG_OPTION_MERGEARGS |
                         MIDNIGHTCODE_CONFIG_OPTION_SILENT )) != 0) {
    midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_FAIL);
  } else {
    midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_OKAY);
  }
/*
  fprintf(stdout, "\n");
  printf("list count [%d]\n", midnightcode_list_count(config_list_head_p));
*/


  // INTERFACE DUMP TEST

  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_NORMAL,
                           "Retrieving all host interfaces");
  if((ret_i = midnightcode_interface_list(interface_list_head_p)) < 0) {
    midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_FAIL);
  } else {
    midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_OKAY);
  }

/*
  midnightcode_list_for_each(now_interface, interface_list_head_p) {
    printf("Interface: %s ", now_interface->name);
    uchar_p = (u_char *)&now_interface->mac_address;
    printf("[%02x:%02x:%02x:%02x:%02x:%02x] ",
            *uchar_p, *(uchar_p + 1), *(uchar_p + 2),
            *(uchar_p + 3), *(uchar_p + 4), *(uchar_p + 5));
    printf("[%s/", inet_ntoa(now_interface->ipv4_address));
    printf("%s] ", inet_ntoa(now_interface->ipv4_mask));
    printf("[%s]\n", inet_ntoa(now_interface->ipv4_broadcast));
    printf("Interface: %s [%s] [%s/%s] [%s]\n",
        now_interface->name,
        now_interface->mac_address_s,
        now_interface->ipv4_address_s,
        now_interface->ipv4_mask_s,
        now_interface->ipv4_broadcast_s);
  }
*/

  fprintf(stdout, "\n\n");



  // EXEC TEST
  midnightcode_status_text(MIDNIGHTCODE_STATUS_TYPE_TEXT,
                           MIDNIGHTCODE_STATUS_STYLE_SOFT,
                           "Exec output .. ");
  int options = 0;
  int pid;
  options |= MIDNIGHTCODE_PROCESS_OPTION_WAITTERM;
  options |= MIDNIGHTCODE_PROCESS_OPTION_NULLIO;
  options |= MIDNIGHTCODE_PROCESS_OPTION_EXITCODE;
  // options |= MIDNIGHTCODE_PROCESS_OPTION_GETPID;
  if((pid = midnightcode_process("./go", options, 0)) != 0) {
    midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_FAIL);
  } else {
    midnightcode_status_flag(MIDNIGHTCODE_STATUS_FLAG_OKAY);
  }

  fprintf(stdout, "\n\n");


  /* List testing

     Note that the INDEX and LOCK extensions add up to 50%
     processing time to all list work;
  
     --- 20 Million Entries
     # NOINDEX, NOLOCK
     real    1m12.377s
     user    0m5.086s
     sys     0m2.801s
     
     # INDEX, LOCK
     real    1m43.043s
     user    0m7.638s
     sys     0m3.319s
     
     --- 10 Million Entries
     # NOINDEX, NOLOCK
     real    0m5.055s
     user    0m2.528s
     sys     0m0.515s
     
     # INDEX, LOCK
     real    0m7.342s
     user    0m3.840s
     sys     0m0.553s

  */

/*
  midnightcode_list_init(list_struct_head, entry_struct_name);
  if(vartwo < 5)
    vartwo = 5;

  op = NULL;
  for(n=1; n<=vartwo; n++) {
    if(!list_silent)
      printf("Append list entry %d\n", n);
    np = malloc(sizeof(struct entry_struct_name));
    memset(np, 0, sizeof(struct entry_struct_name));
    np->test_val = n;
    midnightcode_list_append(&list_struct_head, np);
    if(n==2)
      op = np;
  }
  n = 1999;
  printf("Insert list entry %d\n", n);
  np = malloc(sizeof(struct entry_struct_name));
  np->test_val = n;
  midnightcode_list_insert(&list_struct_head, np);
  printf("List count: %d\n", (&(list_struct_head))->count);

  midnightcode_list_for_each(np, &list_struct_head) {
    if(!list_silent)
      printf("List entry: %d, index=%d\n",
        np->test_val, midnightcode_list_entry_index(np));
  }

  midnightcode_list_for_each(np, &list_struct_head) {
    if(!list_silent)
      printf("List entry: %d, index=%d\n",
        np->test_val, midnightcode_list_entry_index(np));
  }

  printf("Remove list entry 2\n");
  midnightcode_list_remove(&list_struct_head, op);
  printf("Entry 2 was ..\n");
  printf("ent2->test_val = [%d], index = [%d]\n",
    op->test_val, midnightcode_list_entry_index(op));
  free(op);
  printf("List count: %d\n", (&(list_struct_head))->count);

  midnightcode_list_for_each(np, &list_struct_head) {
    if(!list_silent)
      printf("List entry: %d, index=%d\n",
        np->test_val, midnightcode_list_entry_index(np));
  }
  np = (&(list_struct_head))->last;
  printf("Last list entry: %d\n", np->test_val);

  printf("Remove last list entry\n");
  midnightcode_list_remove(&list_struct_head, np);
  free(np);

  printf("----------------\n");

  np = (&(list_struct_head))->last;
  printf("Last: %d, index=%d\n",
    np->test_val, midnightcode_list_entry_index(np));
  np = np->MIDNIGHTCODE_LIST_ENTRIES.prev;
  printf("Last -1: %d, index=%d\n",
    np->test_val, midnightcode_list_entry_index(np));

  printf("List count: %d\n", midnightcode_list_count(&list_struct_head));
*/

  
  exit(0);
}

